// Generated by CoffeeScript 1.3.3
(function() {
  var Cron;

  Cron = (function() {

    function Cron(cronConfig, id, repoDir, serverUser, cronDir) {
      var cf, name;
      this.id = id;
      this.repoDir = repoDir;
      this.serverUser = serverUser;
      this.cronDir = cronDir != null ? cronDir : "/etc/cron.d";
      this.cronJobs = [];
      for (name in cronConfig) {
        cf = cronConfig[name];
        cf.name = name;
        this.cronJobs.push(this.validate(cf));
      }
    }

    Cron.prototype.makeFileName = function(name) {
      return "" + this.cronDir + "/" + this.id + "_cron_" + name;
    };

    Cron.prototype.makeLogFile = function(name) {
      return "cron_" + name + ".txt";
    };

    Cron.prototype.validate = function(cron) {
      if (!cron.name || !cron.time || !cron.command) {
        throw new Error("missing a required parameter for cron, try again");
      }
      return cron;
    };

    Cron.prototype.makeCronScript = function(cron) {
      var logFile;
      logFile = this.makeLogFile(cron.name);
      return "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin\n" + cron.time + " " + this.serverUser + " cd " + this.repoDir + " && " + cron.command + " >> " + logFile + " 2>&1";
    };

    Cron.prototype.makeScript = function(cron) {
      var cronFile, cronScript;
      cronFile = this.makeFileName(cron.name);
      cronScript = this.makeCronScript(cron);
      return "echo \"" + cronScript + "\" > " + cronFile + "\nchmod 0644 " + cronFile;
    };

    Cron.prototype.buildCron = function() {
      var cj, res, _i, _len, _ref;
      res = '';
      _ref = this.cronJobs;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        cj = _ref[_i];
        res += this.makeScript(cj);
        res += "\n";
      }
      return res;
    };

    return Cron;

  })();

  module.exports = Cron;

}).call(this);
