// Generated by CoffeeScript 1.3.3
(function() {
  var MainConfig, path, readConfig;

  path = require("path");

  readConfig = function(f, cb) {
    var m;
    try {
      m = require(f);
    } catch (e) {
      console.log("BAD", e);
      throw e;
      cb(e);
    }
    return cb(null, m);
  };

  MainConfig = (function() {

    function MainConfig(_arg) {
      var layer, name, servers;
      this.start = _arg.start, this.install = _arg.install, this.cron = _arg.cron, servers = _arg.servers;
      this.layers = [];
      for (name in servers) {
        layer = servers[name];
        this.layers[name] = this.normalizeLayer(layer);
      }
    }

    MainConfig.prototype.getLayerByName = function(name) {
      return this.layers[name] || (function() {
        throw new Error("Cannot find server named " + name + ". Check your config file");
      })();
    };

    MainConfig.prototype.getStart = function() {
      return this.start;
    };

    MainConfig.prototype.getInstall = function() {
      return this.install;
    };

    MainConfig.prototype.getLayerNames = function() {
      return Object.keys(this.layers);
    };

    MainConfig.prototype.getCron = function() {
      if (this.cron != null) {
        return this.normalizeCron(this.cron);
      } else {
        return false;
      }
    };

    MainConfig.prototype.normalizeCron = function(cron) {
      var matches, warning;
      if (typeof cron === "string") {
        console.log("using deprecated cron syntax");
        matches = cron.match(/([0-9\s\*]+)\s+(.*)/);
        if (!(matches != null)) {
          throw new Error("Invalid Cron: " + this.cron);
        }
        warning = "you should switch your cron to instead be the following in ggg.js:\n  cron: { cronName: {time: " + matches[1] + ", command: " + matches[2] + " } }";
        console.log(warning);
        cron = {
          "default": {
            time: matches[1],
            command: matches[2]
          }
        };
      }
      return cron;
    };

    MainConfig.prototype.normalizeLayer = function(config) {
      if (typeof config === "string") {
        config = {
          hosts: [config]
        };
      } else if (Array.isArray(config)) {
        config = {
          hosts: config
        };
      } else if (typeof config.hosts === "string") {
        config.hosts = [config.hosts];
      }
      return config;
    };

    return MainConfig;

  })();

  MainConfig.loadFromFile = function(file, cb) {
    return readConfig(file, function(err, config) {
      if (err != null) {
        return cb(err);
      }
      return cb(null, new MainConfig(config));
    });
  };

  module.exports = MainConfig;

}).call(this);
